;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;                                                                     ;;;
;;;                     Carnegie Mellon University                      ;;;
;;;                  and Alan W Black and Kevin Lenzo                   ;;;
;;;                      Copyright (c) 1998-2000                        ;;;
;;;                        All Rights Reserved.                         ;;;
;;;                                                                     ;;;
;;; Permission is hereby granted, free of charge, to use and distribute ;;;
;;; this software and its documentation without restriction, including  ;;;
;;; without limitation the rights to use, copy, modify, merge, publish, ;;;
;;; distribute, sublicense, and/or sell copies of this work, and to     ;;;
;;; permit persons to whom this work is furnished to do so, subject to  ;;;
;;; the following conditions:                                           ;;;
;;;  1. The code must retain the above copyright notice, this list of   ;;;
;;;     conditions and the following disclaimer.                        ;;;
;;;  2. Any modifications must be clearly marked as such.               ;;;
;;;  3. Original authors' names are not deleted.                        ;;;
;;;  4. The authors' names are not used to endorse or promote products  ;;;
;;;     derived from this software without specific prior written       ;;;
;;;     permission.                                                     ;;;
;;;                                                                     ;;;
;;; CARNEGIE MELLON UNIVERSITY AND THE CONTRIBUTORS TO THIS WORK        ;;;
;;; DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING     ;;;
;;; ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT  ;;;
;;; SHALL CARNEGIE MELLON UNIVERSITY NOR THE CONTRIBUTORS BE LIABLE     ;;;
;;; FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES   ;;;
;;; WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN  ;;;
;;; AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,         ;;;
;;; ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF      ;;;
;;; THIS SOFTWARE.                                                      ;;;
;;;                                                                     ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Prosodic phrasing
;;;

;;; Load any necessary files here


(set! estonian_guess_pos
  '(
    (pron     
     ma sa ta me te nad
     mu su
     mind sind meid teid neid
     mul sul tal meil teil neil
     meilt teilt neilt
     meis teis neis
     meist teist neist
     meiks teiks neiks
     see sel need too tol
     kes kel mis kumb ks
     mina sina tema meie teie nemad      
     minu sinu nende
     mulle sulle talle 
     teda  
     minule sinult temale meile teile nendele neile 
     minul sinul nendel 
     minult sinult temalt nendelt 
     minusse sinusse temasse meisse teisse nendesse neisse
     minus sinus temas nendes
     minust sinust temast nendest 
     minuks sinuks temaks nendeks 
     minuni sinuni temani meieni teieni nendeni
     minuna sinuna temana meiena teiena nendena
     minuta sinuta temata meieta teieta nendeta
     minuga sinuga temaga meiega teiega nendega
     selle seda sellesse selles sellest sellele sellel 
     sellelt selleks selleni sellena selleta sellega 
     igasugune igaks iseenese keegi kumb kumbki mes milline mingi mingisugune minusugune 
     mis miski missugune mitmes mitmesugune mitu muu mlema mni      
     mningad mningane niisugune omaenese omasugune sama samasugune see seesama seesinane 
     seesugune selline sihuke srane teineteise teistsugune tema
     temasugune temataoline too ksteise ise eimiski iga kogu kik )
    (interj
     aamen  abil abitult absoluutselt aega aegajalt aeg-ajalt aegamda 
     aeglaselt aeglasemalt aegluubis aegsasti agaralt ah ahaa ahah 
     ahhaa ai aina ainult ainuksi aith ajal ajaliselt ajalooliselt 
     ajapikku ajel ajuti ajutiselt aktiivselt alal alalpmata alasti 
     alatasa alateadlikult alati alatiseks algselt algul alla 
     allapoole alles allpool altkulmu ametlikult ammu ammugi andeks 
     andunult arukalt arusaadavalt arvatavasti arvel arvele arvelt arvukalt
     asemel asemele asjalikult asjata asjatult ausalt automaatselt avalikult
     avameelselt demonstratiivselt dramaatiliselt eales ebamugavalt edasi
     edasi-tagasi edaspidi edukalt eel eelkige eelnevalt eemal eemale 
     eemalt eesktt eespool ehmunult eile 
     eitavalt eks eksimatult elades elavalt enamasti enamjaolt enamvhem 
     enam-vhem endiselt endistviisi energiliselt enesestmistetavalt 
     ennegi ennekike enne erakordselt eraldi eranditult eri eriliselt 
     erinevalt eriti esialgu esile esiteks esmajoones esmakordselt esmalt 
     esteetiliselt et ette etteotsa ettepoole ettevaatlikult formaalselt 
     fsiliselt hakul halastamatult hallo halvasti halvemini harilikult 
     harkisjalu haruharva harva harvemini heaks hilja hiljaaegu hiljaks 
     hiljem hiljuti hingeliselt hirmsasti hirmunult homme hommikuti hoogsalt
     hoolikalt hoolimata hoolimatult hoolitsevalt hoopis hooti hukka hulga
     hulgaliselt hulgas hulgast hulgi hulka hullusti huupi huvitavalt 
     hlpsasti hdasti hmmastavalt hmmeldunult hsti hvasti ideaalselt 
     igasugu igatahes igati igavalt igaveseks igavesti ihusilmaga iial 
     iialgi ikka ikkagi ilma ilmaasjata ilmekalt ilmselgelt ilmselt ilmsesti 
     ilmsiks ilmtingimata ilusasti ilusti imelikult imestunult individuaalselt
     innukalt instinktiivselt iseenesest isegi isekeskis isemoodi iseseisvalt
     iseranis isiklikult istuli jaa jaatavalt jala jalamaid
     jalga jalgsi jalgu jalule jaoks jooksul joostes juba juhuslikult 
     julgelt julgesti julmalt jultunult juriidiliselt justkui justnagu 
     juurde juures juurest jhkralt jude judsalt jul juliselt jlile 
     jljetult jlle jllegi jrel jrele jrelikult jrgi jrgnevalt 
     jrjekindlalt jrjekordselt jrjest jrk-jrgult jrsku jrsult jtkuvalt
     jdavalt kaasas kaastundlikult kaelast kah kahekesi kahevahel kahjuks 
     kahtlaselt kahtlemata kahtlematult kainelt kaldu kallal kallale kallilt 
     kandis kangekaelselt kangesti kannatlikult kannul kaotsi karmilt kasvi 
     kategooriliselt katkendlikult katki kaua kauaks kaudu kauem kaugel kaugele
     kaugelt kaugeltki kaugemal kaugemale kaugemalt kaugusel kauguselt kaunilt
     kaupa kavalalt kenasti kergelt kergemini kergendatult kergesti kerra keset 
     kesk keskel keskele keskelt keskeltlbi keskmiselt kestel kevaditi kihla
     kiirelt kiiremini kiiresti kiivalt kindlalt kindlamalt kindlasti kinni 
     kipras kirjalikult kirjas kitsalt kiuste kodunt koduselt kogemata koguni
     kogunisti kohal kohale kohalt kohapeal kohaselt kohati kohe kohe-kohe 
     kohemaid kohta kohtulikult kohutavalt kokku koledasti kolinal kolmapeviti 
     kolmekesi kombel konkreetselt koomale koost kordamda korduvalt korraga 
     korraks korral korralikult korrapealt korrektselt krampis kramplikult kuhu
     kuhugi kuhupoole kuidagi kuidas kuigi kuigivrd kuivrd kukil 
     kulul kummaliselt kummatigi kummuli kuna kunagi kunas kuni kurvalt 
     kusagil kusagile kusagilt kusjuures kuskil kuskile kuskilt kust kuuldavalt
     kuuldavasti khklemata khklematult kige kigepealt kigest kigiti 
     kikjal kikjale kiksugu krgel krgele krgelt krgemal krgemale 
     krgemalt krval krvale krvalt krvu krvuti kvasti kvemini kes 
     kest kgaras khku kibel kigus ksikes ksil ksile ksitsi ktte 
     klge klili kljes kljest kllaga kllaldaselt kllalt kllap 
     laadi lagedale lahedalt lahedasti lahkelt lahku lahti laiali laialt 
     laiemalt laisalt laitmatult lakkamatult laokil lausa leebelt 
     leplikult ligemale ligi ligidal ligikaudu lihtsalt lihtsamalt liialt 
     liiatigi liigselt lohakalt lokkis loodetavasti loogiliselt loomulikult 
     lootusetult lukku lhki lpetamata lplikult lpuks lpupoole lputult 
     lbi lbini lbinisti lbisegi lhedal lhedale lhedalt lhemal lhemale 
     lhemalt lhistel lhtuvalt lhidalt maadligi maas maatasa madalal madalale
     madalalt madalamal madalamale maha mahti majanduslikult maksimaalselt manu
     massiliselt meeldivalt meelega meeleheitlikult meeleldi meelest meeletult 
     meelsamini meelsasti meeltmda millal millalgi millegiprast 
     milleks minimaalselt misasja misjrel miskiprast mismoodi mispeale mistahes
     mistttu mitmekesi mitmekordselt mitmeti mitte moodi moraalselt mugavalt 
     muide muidu muidugi mujal mujale mujalt mullu muretult muudkui muuhulgas 
     muuseas mistagi mistetavalt mistmatult mistvalt mjul mneti mnevrra 
     mnikord mtlikult mttetult mdukalt mrgatavalt mrkamatult mrksa mda
     mdaminnes mdas na naa nagu nagunii nahka najal najale naljakalt naljalt 
     napilt natuke natukene neljandaks niigi niihsti niikaua niikaugele 
     niikuinii niimoodi niinimetatud niipalju niipea niisama niisamuti niisiis 
     niiviisi niivrd niielda nii-elda nimel nimelt ninapidi nojaa 
     noorelt normaalselt nukralt nnda nndaviisi nrgalt nudlikult nus 
     nusse nutult nhtavale nhtavasti niliselt niteks nol nrviliselt nd 
     ndsama odavalt odavamalt oh ohtlikult ohtralt oi okei olenevalt olgugi 
     oluliselt omaette omajagu omakorda omalt omamoodi omapead omapi omavahel 
     ometi ometigi ootamatult optimistlikult osaliselt osalt osas osavalt otsa otsapidi
     otsas otse otsekohe otsekui otseselt otsesnu otsustavalt paaniliselt pahatihti
     paigal paigale paiguti paiku paistes paksult paljajalu parajalt parajasti 
     paraku paralleelselt parasjagu parata paratamatult paremini peaaegu peaasjalikult
     peagi peal peale pealegi pealekauba pealiskaudselt pealt pealtnha peamiselt 
     peatselt peenelt pehmelt peksa pelgalt pidevalt pidi pidulikult pigem pihta 
     piiramatult piires piisavalt pikali pikalt pikapeale pikemalt piki pikkamisi 
     pikkamda pilgeni pilve pilves pingsalt pingul pingule pisut plehku poliitiliselt
     poole pooleks pooleldi pooleli poolest poolt praegu praktiliselt pshholoogiliselt
     puha puhtalt puhul puhuti purjus purjuspi puruks puudu pgusalt philiselt
     phimtteliselt phjal phjalikult phjalikumalt plvili prmugi pevapealt 
     phe prale pralt prast pri pris priseks priselt prit pl ple phapeviti
     psti raames raevukalt rahul rahule rahulikult rahulikumalt rahumeeli raisku 
     rangelt raskelt raskesti rasva reaalselt regulaarselt reipalt ridamisi rikkis 
     ringi ringis risti rohkem rohkesti rohtu roostes rutem ruttu rhutatult rmsalt 
     rkimata rmas saatel saati sagedamini sagedasti sageli salaja salamisi 
     salapraselt samaaegselt samahsti samamoodi samas samavrd samavrra samm-sammult
     samuti sassi sassis seaduslikult sealhulgas sealjuures sealsamas
     sedakorda sedamaid sedamda sedasi sedasorti sedaviisi sedavrd
     seega seejuures seejrel seekord seelbi seepeale seeprast seestpoolt
     seetttu seevastu segamatult segamini segi sekka selgelt selgesti selili seljataga
     sellal sellegipoolest selleprast selliselt seltsis seni seniajani senikaua seniks
     senini sihilikult siiamaani siia-sinna siinjuures siinkandis
     siinkohal siinmail siinsamas siin-seal siiralt siiski siit siitpeale 
     silmanhtavalt silmapilkselt silmatorkavalt silmitsi sinna sinnapaika sinnasamasse
     sirgelt sisemiselt sisse sissepoole sisuliselt soodsalt sootuks sotsiaalselt 
     suhteliselt suhtes sui suisa sujuvalt sunnil surmavalt suunas suurelt suuremalt 
     suurepraselt suuresti suuruselt suviti sbralikult sltumatult sltuvalt sgaval 
     sgavale sgavalt smpaatselt sndimata sngelt sdi taas tabavalt taga tagant 
     tagantjrele tagaselja tagasi tagasihoidlikult tagurpidi taha tahapoole tahes 
     tahes-tahtmata tahtlikult tahtmatult takistamatult takka talumatult targu tarvis 
     tasa tasapisi tavaliselt tavapraselt tavatult teadagi teadaolevalt teadlikult 
     teadmata teatavasti teel teenimatult tegelikult tegemata tehniliselt teinekord 
     teisal teisalt teiseks teisisnu teisiti teistmoodi teistpidi telefonitsi teoksil 
     teoreetiliselt teps teraselt teravalt teravamalt tere tervelt tihedalt tihedamini 
     tihti tihtipeale tingimata toel tohutult tollal tookord toona traagiliselt trotslikult
     tublisti tugevalt tugevamini tugevasti tuhmilt tulemata tulenevalt tulvil tummalt 
     tunduvalt tungivalt tunnustavalt tusaselt teliselt temeeli tenoliselt tepoolest 
     testi thusalt tsiselt tsisemalt tttu ttt-elda thele thelepanelikult tielikult 
     tiesti titsa tna tnaseks tnaseni tnavu tnini tpselt tpsemalt tpsemini tdinult
     thjalt tlis tlli uhkelt umbes umbkaudu umbusklikult usinalt usinasti uskumatult uuesti
     vaatamata vabalt vabatahtlikult vaevaliselt vaevalt vaevumrgatavalt vahel vaheldumisi 
     vahele vahelt vahepeal vahest vahetevahel vahetpidamata vahetult vaieldamatult vaikselt
     vaimselt vait vaja valdavalt valesti valju valjult valjusti valla valusalt valvel vanasti 
     varakult varal vargsi varjus varsti vasakul vasakule vasakult vast vastamisi vastas vastastikku
     vastavalt vastu vastupidi vastupidiselt veelkord veendunult veenvalt veidi veidike vihaselt
     viimaks viimati viisakalt viisi viivitamatult villand viltu visalt vististi vibolla 
     vib-olla vidukalt vimalikult vlgu vrdlemisi vrdselt vrra vrsil vga vgisi vhe vhegi
     vhehaaval vheks vhemalt vhemasti vliselt vlja vljakutsuvalt vljapoole vljas vljaspool
     vljast vljastpoolt vltel vrskelt vsimatult vsinult vrikalt vrt hinal htuti ieli 
     ieti igeaegselt igemini igesti iglaselt igupoolest lule nnelikult nnetult rnalt ue 
     ues uest gedalt hvardavalt kitselt kki revalt revil rkvel sja rde repealt res 
     rest retult rmiselt seks sel siti ha heaegselt hekaupa hekorraga hemtteliselt
     hes heskoos hesnaga hiselt htaegu hte htejrge htekokku htemoodi htlaselt htlasi 
     htmoodi htpidi ht-teist htviisi htkki ksi ksikult ksinda kskord kskik kskikselt
     ksmeelselt ksnes lal lalt ldiselt ldjoontes ldse le learu leeile lehomme leliia
     lemra leni leolevalt les les-alla lesmge lespidi lespoole lesse leval levalt
     le leldse limalt livga llatavalt llatunult mber mberringi mbert pris sna
     tlemata tis valmis palju kaasa koos kord lahus liiga looja pea puru saadik soo tnu
     vara pool ra  
     )
    (neg ei )
 		(con ja ning ehk ehkki vi kui ka kuid ent vaid elik sest sestap ega egas)
    (copula on)
		(adp sees seest all alt ees eest seas seast peal pealt eel heaks jaoks kes koos )
    (adv vist kas las ju siis veel kll just no noh jah nojah vaat koost siin siit kust mil miks 
     seal sealt kus nii all alt ees eest siia siiani )	
		(punc "." "," ":" ";" "\"" "'" "(" "?" ")" "!")
))


;(set! estonian_guess_pos
;  '(
;    (neg ei )
; 		(con ja ning ehk vi kui ka kuid ent vaid elik sest )
;    (copula on)
;		(adp sees seest all alt ees eest seas seast peal pealt eel heaks jaoks kes koos )
;    (adv vist kas las ju siis ka veel kll just no jah vaat ehk koost siin siit kust mil miks 
;     seal sealt kus nii all alt ees eest )	
;		(punc "." "," ":" ";" "\"" "'" "(" "?" ")" "!")
;))


(define (word-is-content? word guess_pos)
  (cond
   ((null guess_pos) t)
   ((member_string word (cdr (car guess_pos))) nil)
   (t 
		(word-is-content word (cdr guess_pos)))
))



(define (since_punctuation word)
 "(since_punctuation word)
Number of words since last punctuation or beginning of utterance."
;	(print word)
;	(if (word-is-content word guess_pos)
;	(print "on kontent")
;	)
 (cond
   ((null word) 0) ;; beginning or utterance
   ((string-equal "0" (item.feat word "p.lisp_token_end_punc")) 0)
   (t
    (+ 1 (since_punctuation (item.prev word))))))

(define (until_punctuation word)
 "(until_punctuation word)
Number of words until next punctuation or end of utterance."
 (cond
   ((null word) 0) ;; beginning or utterance
   ((string-equal "0" (token_end_punc word)) 0)
   (t
    (+ 1 (since_punctuation (item.prev word))))))


(set! eki_et_phrase_cart_tree_2
'
((lisp_token_end_punc in ("." "?" "!" ";"))
  ((BB))
  ((lisp_token_end_punc in ("'" "\"" "," ":"))
   ((B))
   ((n.name is 0)  ;; end of utterance
    ((BB))
    ((lisp_since_punctuation > 0)
     ((lisp_until_punctuation > 0)
      ((gpos is content)
       ((n.gpos content)
        ((NB))
        ((B)))   ;; not content so a function word
       ((NB)))   ;; this is a function word
      ((NB)))    ;; to close to punctuation
     ((NB)))     ;; to soon after punctuation
    ((NB))))))


(set! eki_et_phrase_cart_tree
'
((lisp_token_end_punc in ("?" "." ":"))
  ((B))
  ((lisp_token_end_punc in ("'" "\"" "," ";"))
   ((BB))
   ((n.name is 0)  ;; end of utterance
    ((B)) 
    ((NB)))))

); set


(set! eki_et_phrase_cart_tree_3
'
((lisp_token_end_punc in ("." "?" "!" ";"))
  ((BB))
  ((lisp_token_end_punc in ("'" "\"" "," ":"))
   ((BB))
  ((R:Token.parent.n.name in ("ja" "ning" "ega" "ehk" "vi"))
   ((BB))
   ((n.name is 0)  ;; end of utterance
    ((BB))
    ((lisp_since_punctuation > 2)
     ((lisp_until_punctuation > 2)
      ((gpos is content)
       ((n.gpos content)
        ((NB))
        ((BB)))   ;; not content so a function word
       ((NB)))   ;; this is a function word
      ((NB)))    ;; to close to punctuation
     ((NB)))     ;; to soon after punctuation
    ((NB)))))))



(define (eki_et_tonu::select_phrasing)
  "(eki_et_tonu::select_phrasing)
Set up the phrasing module for English."
  (set! guess_pos estonian_guess_pos)
  (set! phrase_cart_tree eki_et_phrase_cart_tree_3)
  (Parameter.set 'Phrase_Method 'cart_tree)
)

(define (eki_et_tonu::reset_phrasing)
  "(eki_et_tonu::reset_phrasing)
Reset phrasing information."
  t
)

(provide 'eki_et_tonu_phrasing)







