<?php
/*
 * Mysql Ajax Table Editor
 *
 * Copyright (c) 2008 Chris Kitchen <info@mysqlajaxtableeditor.com>
 * All rights reserved.
 *
 * See COPYING file for license information.
 *
 * Download the latest version from
 * http://www.mysqlajaxtableeditor.com
 */
require_once('Common.php');
require_once('php/lang/LangVars-et.php');
require_once('php/AjaxTableEditor.php');

class Sonastik extends Common
{
	var $Editor;
	
	function displayHtml()
	{
		?>
			<br />
	
			<div align="left" style="position: relative;"><div id="ajaxLoader1"><img src="images/ajax_loader.gif" alt="Loading..." /></div></div>
			
			<br />
			
			<div id="historyButtonsLayer" align="left">
			</div>
	
			<div id="historyContainer">
				<div id="information">
				</div>
		
				<div id="titleLayer" style="padding: 2px; font-weight: bold; font-size: 18px; text-align: center;">
				</div>
		
				<div id="tableLayer" align="center">
				</div>
				
				<div id="hiLayer" align="center" style="text-align: center; margin-left: 600px;">
Märgid: <b>&apos;</b> rõhk, <b>+</b> vaba kasutus, nt "olen üle vaadanud"
				</div>
				
				<div id="recordLayer" align="center">
				</div>
				
				<div id="searchButtonsLayer" align="center">
				</div>
			</div>
			
			<script type="text/javascript">
				trackHistory = false;
				var ajaxUrl = '<?php echo $_SERVER['PHP_SELF']; ?>';
				toAjaxTableEditor('update_html','');
			</script>
		<?php
	}

function haalda ($info) {
    $id = $info['ID'];
    $suva = '?' . substr(MD5(microtime()),0,6);
    $supaid = 'supa' . $id;
    $iconHtml = '<li class="myicon">' .
	'<audio id="'.$supaid.'" preload="none">' .
	'<source src="/audio/sonastik/id'.$id.'.wav'.$suva.'" type="audio/wav">' .
	'<source src="/audio/sonastik/id'.$id.'.mp3'.$suva.'" type="audio/mpeg">' .
	'</audio>' .
	'<a href="javascript:document.getElementById(\''.$supaid.'\').play();" title="Kuula"></a></li>';
    return array('icon_html' => $iconHtml, 'num_icons' => 1);
}

# E edit, A add, C copy, V view, D delete, X export

	function initiateEditor()
	{
		$tableColumns['ID'] = array('display_text' => 'ID', 'perms' => 'TQO');
		$tableColumns['sone'] = array('display_text' => 'Sõne',       'perms' =>   'ETAVQSXO');
		$tableColumns['keel'] = array('display_text' => 'keel',       'perms' => 'EVCTAXQSHO');
		$tableColumns['haaldus'] = array('display_text' => 'Hääldus', 'perms' => 'EVCTAXQSHO');
		
		$tableName = 'sonastik';
		$primaryCol = 'ID';
		$errorFun = array(&$this,'logError');
//		$permissions = 'EAVIDQCSXHO';
		$permissions = 'EADXQSHOUMI';
		
		$this->Editor = new AjaxTableEditor($tableName,$primaryCol,$errorFun,$permissions,$tableColumns);
		$this->Editor->setConfig('tableInfo','cellpadding="1" width="1000" class="mateTable"');
		$this->Editor->setConfig('orderByColumn','sone');
		$this->Editor->setConfig('addRowTitle','Lisa kirje');
		$this->Editor->setConfig('editRowTitle','Muuda kirjet');

$userIcons[] = array('format_fun' => array(&$this,'haalda'));
$this->Editor->setConfig('userIcons',$userIcons);
	}
	
	
	function Sonastik()
	{
		if(isset($_POST['json']))
		{
			session_start();
			// Initiating lang vars here is only necessary for the logError, and mysqlConnect functions in Common.php. 
			// If you are not using Common.php or you are using your own functions you can remove the following line of code.
			$this->langVars = new LangVars();
			$this->mysqlConnect();
			if(ini_get('magic_quotes_gpc'))
			{
				$_POST['json'] = stripslashes($_POST['json']);
			}
			if(function_exists('json_decode'))
			{
				$data = json_decode($_POST['json']);
			}
			else
			{
				require_once('php/JSON.php');
				$js = new Services_JSON();
				$data = $js->decode($_POST['json']);
			}
			if(empty($data->info) && strlen(trim($data->info)) == 0)
			{
				$data->info = '';
			}
			$this->initiateEditor();
			$this->Editor->main($data->action,$data->info);
			if(function_exists('json_encode'))
			{
				echo json_encode($this->Editor->retArr);
			}
			else
			{
				echo $js->encode($this->Editor->retArr);
			}
		}
		else if(isset($_GET['export']))
		{
            session_start();
            ob_start();
            $this->mysqlConnect();
            $this->initiateEditor();
            echo $this->Editor->exportInfo();
            header("Cache-Control: no-cache, must-revalidate");
            header("Pragma: no-cache");
            header("Content-type: application/x-msexcel");
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="'.$this->Editor->tableName.'.csv"');
            exit();
        }
		else
		{
			$this->displayHeaderHtml();
			$this->displayHtml();
			$this->displayFooterHtml();
		}
	}
}
$lte = new Sonastik();
?>