#!/usr/bin/perl -w

use strict;
use File::Pid;
use DBI();
use utf8;

# kutsutakse cron-ist kindla x-minutilise intervalliga
# kord paevas on igati OK, selle arvestusega me vaatame ainult eetri kuupaeva

my $kuimitu_paeva_hoiame = 10;

# -------------------------------------------------------------

$| = 1;
my $log = '/var/www/programmid/log/supa.log';
if (! -e $log) {
    `touch $log`;
    `chown www-data:www-data $log`;
}
open (LOG, ">>$log");
binmode (LOG, ":utf8");


# Leiame baasist subtiitrite nimekirja ja ...

my $dbh = DBI->connect ("DBI:mysql:<BAAS>:localhost", "<KASUTAJA>", "<PAROOL>", {'RaiseError' => 1});
$dbh->{'mysql_enable_utf8'} = 1;
$dbh->do ("SET NAMES 'utf8'");
print LOG "Puhastaja: logisin baasi sisse, yritan kustutada asju, mis on rohkem kui $kuimitu_paeva_hoiame paeva yle eetriaja\n";

my $sth = $dbh->prepare ('SELECT id, nimi FROM j_subtiitrid WHERE eetris_kuupaev < CURDATE() - INTERVAL ? DAY');
$sth->execute($kuimitu_paeva_hoiame);

my @kustu_idd = ();
my @kustu_nimed = ();

while (my ($id_sub, $nimi) = $sth->fetchrow_array() ) {
    print "$nimi ($id_sub)\n";
    print LOG "Puhastaja: kustutan $nimi (id $id_sub)\n";
    push @kustu_idd, $id_sub;
    push @kustu_nimed, $nimi;
}

foreach my $id_sub (@kustu_idd) {
    print "Ohvri ID on $id_sub\n";
    kustuta_cb_subtiiter ($id_sub);
    kustuta_cb_kirje ($id_sub);
    my $id_art = kustuta_cb_artikkel ($id_sub);
    kustuta_j_artikkel ($id_art);
}

foreach my $nimi (@kustu_nimed) {
    kustuta_failid ($nimi);
}



sub kustuta_cb_subtiiter {
    my $id = shift;
    my $h = $dbh->prepare ('DELETE FROM j_subtiitrid WHERE id = ?');
    $h->execute($id);
    print LOG "Puhastaja: kustutasin j_subtiitrid id $id\n";
}

sub kustuta_cb_kirje {
    my $id = shift;
    my $h = $dbh->prepare ('DELETE FROM j_contentbuilder_records WHERE record_id = ?');
    $h->execute($id);
    print LOG "Puhastaja: kustutasin j_contentbuilder_records record_id $id\n";
}

sub kustuta_cb_artikkel {
    my $id = shift;
    # ka CB artiklit ei pruugi olla
    return 0 unless $id;

    my $h = $dbh->prepare ('SELECT article_id FROM j_contentbuilder_articles WHERE record_id = ?');
    $h->execute($id);
    my ($aid) = $h->fetchrow_array();

    $h = $dbh->prepare ('DELETE FROM j_contentbuilder_articles WHERE record_id = ?');
    $h->execute($id);
    print LOG "Puhastaja: kustutasin j_contentbuilder_articles record_id $id\n";

    return $aid;
}

sub kustuta_j_artikkel {
    my $id = shift;
    # joomla artiklit ei pruugi olla
    return unless $id;

    my $h = $dbh->prepare ('DELETE FROM j_content WHERE id = ?');
    $h->execute($id);
    print LOG "Puhastaja: kustutasin j_content id $id\n";
}

sub kustuta_failid {
    my $n = shift;
    $n =~ s/[^a-zA-Z_\-0-9]//go;
    return unless $n;
    my $d = '/var/www/programmid/work/' . $n;
    if (-d $d) {
	print LOG "Puhastaja: puhastan $d helifailidest\n";
	$d .= '/*';
	foreach my $f ( glob($d) ) {
	    next unless $f =~ /\.(wav|mp3)/;
	    # print "\t$f\n";
	    unlink ($f);
	}
    } else {
	print LOG "Puhastaja: $d puudub?\n";
    }
}

close (LOG);
