#!/usr/bin/perl -w

# Parameetrid:
# täisteega .srt failinimi
# [ajanihe sekundites]
# [hääle nr]

my $debug = 0;

my $srt = shift;
my $ajanihe = shift;
$ajanihe = 0 unless defined $ajanihe;

my $haal = shift;	# liisi puhul alustame veidi varem, tonul loikame algust ara
$haal = 6 unless defined $haal;

# R.S.: Kui saaksite genereerida ühe WAV faili (PCM, 48kHz, 16bit, stereo või mono)
$bitte = 16;		# bits per sample
$sagedus = 48000;	# sampling rate
$kanaleid = 1;		# 1 mono
$baitesekundis = $bitte/8 * $sagedus;
$helikogupikkus = 0;

$pikempaus = 0.8;	# 600 ms mõttepunktid, kõnelejavahetus
$lyhempaus = 0.4;	# 400 ms lausete vahel ( . ? ! )

$lisaparams = '';
if ($haal == 3) {
    $lisaparams = '  trim 0.075';	# see loikab Tonu algusest kropsu
}

die "Sisendiks /bla/bla/bla/subtiitrifail.srt\n" unless $srt;
$wdir = ( $srt =~ /.*\// ? $& : './' );

my $lock = $wdir . 'yhenda.lukk';
my $log = $wdir . 'yhenda.log';

if (-e $lock) {
    $log = $wdir . 'yhenda_vana_lukk_keelas';
#    unlink ($log);
    open (LOG, ">$log");
    print LOG "Ei saa siin alustada, fail on lukus\n";
    close (LOG);
    exit;
}

if (-e $log) {
    open (LOG, ">>$log");
} else {
    #unlink ($log);
    open (LOG, ">$log");
}

if (not -e $srt) {
	print LOG "Sisendfail $srt puudub\n";
	close (LOG);
	die "Sisendfail $srt puudub\n";
}

open (SRT, "<$srt");

$srt = $` if $srt =~ /\.srt$/i;
my $raw = "$srt.raw";
my $wav = "$srt.wav";

#
# Lukku, selgub, on vaja, sest X-megase faili solgutamine võib
# kauem aega võtta, kui uus peale tuleb, kõik kustutab ja otsast alustab.
#
open (LOCK, ">$lock");
print LOCK time;
close (LOCK);


unlink ($raw) if -e $raw;
unlink ($wav) if -e $wav;

# initsialiseerime kymnendiksekundise vaikusega
liidavaikus (0.1);

$sn = 0;
$liigapikk = 0;

while ($s = <SRT>) {
    chomp $s;

    # tyhi rida
    next unless $s;

    # rida supa numbriga
    if ($s =~ /^(\d+)$/) {
	$uusnumber = $1;
	if ($uusnumber < $sn) {
	    print LOG "Oli $sn, tuli $uusnumber. Valmis, lopetan\n";
	    last;
	}
	$sn = $uusnumber;
	print LOG "supa nr $sn\n";
	next;
    }

    # rida supa algus- ja lopuaegadega
    # see ongi see osa, mida vaja, tekst meid ei huvita

    if ($s =~ /^(\d+):(\d+):(\d+),(\d+).+(\d+):(\d+):(\d+),(\d+)$/) {
	$supaalgus = 3600 * $1 + 60 * $2 + $3 + $4 / 1000;
	$supalopp  = 3600 * $5 + 60 * $6 + $7 + $8 / 1000;

	# Lintmaki 10tunnine ajanihe, aga pole parameetrina antud
	if (($ajanihe == 0) and ($1 >= 10)) {
	    $ajanihe = 36000;
	    print LOG "NB Eemaldan 10tunnise algusaja!\n";
	}

	$supaalgus -= $ajanihe;
	$supalopp -= $ajanihe;
	$supapikkus = $supalopp - $supaalgus;

	# print LOG "... supa algus $supaalgus sekundit\n";
	$vaikus = sprintf ("%.3f", $supaalgus - &pikkus($raw));

	# eksperimentaalselt alustame liisit enne supa algust 50 ms
	if ($haal == 1) { $vaikus -= 0.050; }

	if ($vaikus < 0) {
	    print LOG "$sn: Eelmine supa jookseb sisse $vaikus sekundit!\n";
	    $vaikus = 0.01;
	}
	&liidavaikus ($vaikus);

	my $l = &liidasupa ($sn);
	$helikogupikkus += $l;
	if ( $l > $supapikkus) {
	    print LOG "$sn: lubatud pikkus $supapikkus, aga helil $l ";
	    $l = sprintf ("%.3f", $l - $supapikkus);
	    print LOG "($l sek yle)\n";
	    $liigapikk = 1;
	}
	next;
    }

    # tekst
    if ($liigapikk) {
	print LOG "Liiga pikk nr $sn: $s\n";
	$liigapikk = 0;
    }
}

print LOG "\nHaal $haal, heli kogupikkus $helikogupikkus\n";

close (SRT);
close (LOG);


# iluks sekund vaikust viimase otsa
liidavaikus (1);

print "sox -r $sagedus -b $bitte -c $kanaleid -e signed-integer $raw $wav\n";
system ("sox -r $sagedus -b $bitte -c $kanaleid -e signed-integer $raw $wav");

sleep(1);
unlink ($lock);
unlink ($raw);




# ----------------------------------------------------------

# tagastab hetkel valmis tehtud raw pikkuse sekundites
sub pikkus {
    my $fn = shift;
    return 0 unless -e $fn;
    my $pikkus = -s $fn;
    print LOG "... $fn pikkus hetkel $pikkus, mis on " if $debug;
    $pikkus = $pikkus/$baitesekundis;
    print LOG "$pikkus sekundit\n" if $debug;
    return $pikkus;
}

# lisab n sekundit vaikust augu taiteks
sub liidavaikus {
    my $sec = shift;
    if (-e $raw) { open (RAW, ">>$raw"); } else { open (RAW, ">$raw"); }
    binmode (RAW);
    # et nullide arv oleks ymar, meil 16 bitti = kahekaupa
    my $mitunulli = int (($baitesekundis*$sec) / ($bitte/8)) * ($bitte/8);
    print LOG "liidan $sec sekundit ehk $mitunulli nulli vaikust\n" if $debug;
    for (1..$mitunulli) { printf RAW ("%c", 0); }
    close (RAW);
}

sub yhendajupid {
    my $supanr = shift;
    my $jupimask = $wdir . '/sn' . $supanr . '_*';
    my @jupid = glob ($jupimask);
    # kui juppe pole, me tööd ei tee
    return unless scalar(@jupid);

    print LOG "Supa nr $supanr koosneb juppidest. Yhendan.\n";

    $tmpraw = "$wdir/sn$supanr.tmp.raw";
    $reswav = "$wdir/sn$supanr.wav";
    $resraw = "$wdir/sn$supanr.res.raw";
    `touch $resraw`;

    foreach my $j (sort @jupid) {
	print LOG "$j\n";

	my $sec = ($j =~ /p\.wav/ ? $pikempaus : $lyhempaus);

	# liidame eelnenule vajalikul hulgal vaikust
	open (RESRAW, ">>$resraw");
	binmode (RESRAW);
	my $mitunulli = int (($baitesekundis*$sec) / ($bitte/8)) * ($bitte/8);
	for (1..$mitunulli) { printf RESRAW ("%c", 0); }
	close (RESRAW);

	# jupp raw formaati
	system ("sox $j -r $sagedus -b $bitte -c $kanaleid -e signed-integer $tmpraw $lisaparams");

	# ja liidame rulemusele
	`cat $tmpraw >>$resraw`;
	`rm $tmpraw`;
    }

    # saadud .raw ilu pärast tagasi .wav-iks
    unlink ($reswav) if -e $reswav;
    system ("sox -r $sagedus -b $bitte -c $kanaleid -e signed-integer $resraw $reswav");
    print LOG "Tegin $reswav\n";
    `rm $resraw`;

    $tmpraw = "$wdir/sn$supanr.mp3";
    unlink ($tmpraw) if -e $tmpraw;
    # siin peaks heli_valmis protsendi ka 100 peale kiskuma, aga see tükk baasiga ei suhtle
}

sub liidasupa {
    my $supanr = shift;

    # see teeb kui saab, juppidest uue $supwav
    yhendajupid ($supanr);

    $supwav = "$wdir/sn$supanr.wav";
    $supraw = "$wdir/sn$supanr.raw";
    if (not -e $supwav) {
	print LOG "Supal nr $supanr puudub vastav .wav\n";
	return;
    }
    if (-s $supwav < 10) {
	print LOG "Supa nr $supanr on suhtkoht tyhi\n";
	# Ei liida midagi ja tagastame selle wavi pikkusena 0
	return 0;
    }

    my $jupimask = $wdir . '/sn' . $supanr . '_*';
    print LOG "$jupimask\n";
    my @jupid = glob ($jupimask);
    if ( scalar(@jupid) ) {
	print LOG "Supa nr $supanr koosneb juppidest: ";
	foreach my $j (sort @jupid) { print LOG "$j "; }
	print LOG "\n";
    }

    system ("sox $supwav -r $sagedus -b $bitte -c $kanaleid -e signed-integer $supraw $lisaparams");
    print LOG "Liidan $supanr\n";
    my $l = &pikkus($supraw);
    if ($l) {
	`cat $supraw >>$raw`;
	`rm $supraw`;
    }
    print LOG "... pikkusega $l\n";
    return $l;
}

