#!/usr/bin/perl -w
use utf8;
use DBI();

# parameetrid
# [-i] sisendfaili nimi		peab olema
# -h 				hääl, vaikimisi tonu_hts
# -hh				hääle sees kõnelejavahetused

my $eelmine = '';
my ($srt, $log, $h, $hh) = 0;

foreach (@ARGV) {
    if ($_ =~ /^\-/) {
	$eelmine = $_;
	$hh = 1 if $_ eq '-hh';
	next;
    }
    $srt = $_ if $eelmine eq '-i';
    $h = $_ if $eelmine eq '-h';
    # ju siis sisendfail
    $srt = $_ if $eelmine eq '';
    $eelmine = '';
}

$srt = '' unless $srt =~ /\.srt$/;
my $fst = $` . '.fst';
$srt =~ /.*\//;
my $workdir = $&;

if (! $srt) {
    print "Sisendfail puudu voi pole .srt laiendiga!\n";
    print "Parameetrid on:\n";
    print "[-i] sisendfail\n";
    print "[-h hääle number]\n";
    print "[-hh] imiteeri kõnelejavahetusi\n";
    exit;
}

open (SRT, "<$srt") or die "Ei saa avada $srt";
binmode (SRT, ":utf8");

$/ = "";

open (FST, ">$fst");
binmode (FST, ":encoding(ISO-8859-15)");

print FST '(voice_eki_et_tonu_hts)' . "\n";

our $dbh = DBI->connect ("DBI:mysql:<BAAS>:localhost", "<KASUTAJA>", "<PAROOL>", {'RaiseError' => 1});
$dbh->{'mysql_enable_utf8'} = 1;
$dbh->do ("SET NAMES 'utf8'");

require "/var/www/programmid/bin/supa_protseduurid.pl";

while (<SRT>) {
    chomp;
    my ($sn, $ajad, $st) = split /\n/;

    # kui juhtub, et .srt on vigane (kellaaegade sees paar tyhja rida)
    # niisama next ei tohi. subtiiter peab tekitama wav-i, muidu jaame tsyklisse
    $st = '...' unless ($st);

    # juba olemas wav-e me siin uuesti ei tee, muidu võib igavesti tegema jääda
    next if -e $workdir . '/sn' . $sn . '.wav';

    # vene keel - transkribeerida või üldse välja jätta
    $st = transkribeeri($st) if $st =~ /[\x{400}-\x{4ff}]/;

    $st =~ s/\x{2028}/ /g;

    $st =~ s/[[:alpha:]\']+/haaldus($&)/eg;

    print FST fst_tervik ($st, $sn, $hh);
    print FST fst_jupid ($st, $sn, $hh);

}

close (SRT);
close (FST);

