#!/usr/bin/perl -w

use utf8;
use lib '/var/www/programmid/bin';
use Numbers;
use Lyhvrk;

# parameetrid
# [-i] sisendfaili nimi		peab olema

my $eelmine = '';
my ($srt, $log) = 0;

foreach (@ARGV) {
    if ($_ =~ /^\-/) {
	$eelmine = $_;
	next;
    }
    $srt = $_ if $eelmine eq '-i';
    # ju siis sisendfail
    $srt = $_ if $eelmine eq '';
    $eelmine = '';
}

$srt = '' unless $srt =~ /\.srt$/i;

if (! $srt) {
    print "Sisendfail puudu voi pole .srt laiendiga!\n";
    print "Parameetrid on:\n";
    print "[-i] sisendfail\n";
    exit;
}

# logi samasse kataloogi, kus oli srt
$log = $` . '.log';
if (-e $log) {
    open (LOG, ">>$log");
} else {
    open (LOG, ">$log");
}
binmode (LOG, ":utf8");

#$srt =~ /.*\//;
#my $workdir = $&;

open (SRT, "<$srt") or die "Ei saa avada $srt";
binmode (SRT, ":utf8");
my @srt = ();
do {
    local $/ = "";
    @srt = (<SRT>);
};
close (SRT);

open (SRT, ">$srt") or die "Ei saa avada $srt";
binmode (SRT, ":utf8");
foreach (@srt) {
#    chomp;
    my ($sn, $ajad, $st) = split (/\n/, $_, 3);
    print SRT "$sn\n$ajad\n";

    if (! $st) {
	print "EI SISALDANUD SUPA TEKSTI: $_\n\n"; last;
    }
    # st võib olla mitmerealine
    $st =~ s/\n/ /gs;
    $st = $` if $st =~ /\s+$/;		# eemaldame supasid eraldanud reavahetused
    my $st_sisse = $st;

    $st =~ s/\x{b0}C/ kraadi/g;
    $st =~ s/\x{b0}K/ kelvini kraadi/g;
    $st =~ s/\x{b0}F/ farenheiti kraadi/g;
    $st =~ s/\x{b0}/ kraadi/g;

    # p-o-m-m-e
    $st =~ s/(\pL\-){2,}\pL/kriipstyhikuks($&)/eg;

    # CO2 -> tsee oo2 on halb (-> oo oo kaks), vaja on -> tsee oo kaks
    $st =~ s/(\pL+)([0-9]+)/sonadeks($1) . ' ' . $2/eg;
    # lyhendites eeldame märke . / ja tähed
    $st =~ s/[\pL\.\/]+/sonadeks($&)/eg;

    if ($st_sisse ne $st) {
	print LOG "Oli: $st_sisse\n";
	print LOG "Sonadeks: $st\n\n";
    }

    # Mh, Mhmh, hmmm, ...
    $st =~ s/[MH][mh]*m([,.! ])/hõm$1/g;

    # 200 kraadini
    $st =~ s/ (\d+) (\pL+?)(ni)([ .])/' ' . number_to_word($1, 'gen') . ' ' . $2 . $3 . $4/eg;

    # 1930. aasta
    # Kahjuks nimetav ja omastav on ennustamise asi:
    #   1930. aasta möödus vaikselt
    #   1930. aasta näljahäda jääb meelde
    $st =~ s/(\d{3,4})\. aasta(?![a-z])/number_to_word($1, 'ord') . ' aasta'/eg;
    # 1930. aastat
    $st =~ s/(\d{3,4})\. aastat(?![a-z])/number_to_word($1, 'ord', 'part') . ' aastat'/eg;
    # 1930. aasta(sse|...)
    $st =~ s/(\d{3,4})\. aasta(sse|s|st|le|l|lt|ks)(?![a-z])/number_to_word($1, 'ord', $2) . ' aasta' . $2/eg;
    # 1930. aasta(ni|na|ta|ga)
    $st =~ s/(\d{3,4})\. aasta(ni|na|ta|ga)(?![a-z])/number_to_word($1, 'ord', 'gen') . ' aasta' . $2/eg;

    # 10-12
    $st =~ s/(\d+)\-(\d+)/number_to_word($1) . ' kuni ' . number_to_word($2)/eg;

    # 10.12 kui mónikord isegi on 'punkt' vaja öelda, siis reeglina mitte: kell seitse null viis, maksis 11 20
    # aga nóuame mólemat kuni kahekohalist, esimene vóib olla ühekohaline
    while ( $st =~ /([ ])(\d)?(\d)\.(\d)(\d)(?=[ .])/ ) {
	my $ees = $` . $1;
	my $taga = $';
	if ($2 eq '0') { $ees .= ' null ' . number_to_word($3) }
	    else { $ees .= number_to_word($2.$3); }
	$ees .= ' ';
	if ($4 eq '0') { $ees .= ' null ' . number_to_word($5) }
	    else { $ees .= number_to_word($4.$5); }
	$ees .= ' ';
	$st = $ees . $taga;
    }

    # 12%-lt, 13%-ni, 99%, 97,5%
    # jah, numvrk lubab käände määramiseks kasutada käändelõppu
    $st =~ s/(\d+)\s*\%\-(s|st|le|l|lt|ks)/number_to_word($1, $2) . ' protsendi' . $2/eg;
    $st =~ s/(\d+)\s*\%\-(ni|na|ta|ga)/number_to_word($1, 'gen') . ' protsendi' . $2/eg;
    $st =~ s/(\d+)\s*\%/number_to_word($1) . ' protsenti '/eg;
    $st =~ s/(\d+)[,.](\d+)\s*\%/number_to_word($1) . ' koma ' . number_to_word($2) . ' protsenti '/eg;

    # 80ndatest
    $st =~ s/(\d+)\-?(nd[a-z]+)/number_to_word($1, 'gen') . $2/eg;

    # 15-aasta(ne|st|..)
    $st =~ s/(\d+)\-?(aasta[a-z]*)/number_to_word($1, 'gen') . ' ' . $2/eg;

    # EKGsse
    $st =~ s/(^|\PL)(\p{uppercase}+)(\p{lowercase}+)(\PL|$)/$1.sonadeks($2).$3.$4/eg;

    # a-tähega, b-ga
    # tulemus: aasta-tähega
    #$st =~ s/(\pL\pL+)\-([\pL]+)/sonadeks($1).' '.$2/eg;


    if ($st_sisse ne $st) {
	print LOG "Oli: $st_sisse\n";
	print LOG "Sai: $st\n\n";
    }
    print SRT "$st\n\n";
}
close (SRT);
close (LOG);

sub kriipstyhikuks {
    my $s = shift;
    $s =~ s/\-/ /g;
    print LOG "kriipsutustasin $s\n";
    return $s;
}
