#!/usr/bin/perl -w

# parameetrid
# [-i] sisendfaili nimi		peab olema
#				valikuliselt:
# [-k] väljundkataloog		kui puudub, teeme sfailinimega .dir-lopulise alakataloogi
# -t				tee ka tekstifail sub numbritega (vajalik morf analüüsile)
# -l				tee ka logifail
# -f				tee ka festivali sisend
# -u				loe 'kasutaja' subtiitreid (FE) tavapärase (FF) asemel

my $eelmine = '';
my ($stl, $dir, $txt, $log, $fst, $usr, $ajanihe) = 0;

foreach (@ARGV) {
    if ($_ =~ /^\-/) {
	if (/^\-[ikn]$/) { $eelmine = $_; next; }
	$eelmine = '';
	$txt = $txt || ($_ eq '-t');
	$log = $log || ($_ eq '-l');
	$fst = $fst || ($_ eq '-f');
	$usr = $usr || ($_ eq '-u');
	next;
    }
    # aga kui ei olnud kriipsuga algav, siis
    if ($eelmine) {
	$stl = $_ if $eelmine eq '-i';
	$dir = $_ if $eelmine eq '-k';
	$ajanihe = $_ if $eelmine eq '-n';
	$eelmine = '';
    }
    # ju siis sisendfail või kataloog
    elsif ($stl) { $dir = $_; }
    else { $stl = $_; }
}

if (! $stl) {
    print "Puudub sisendfaili nimi!\n";
    print "Parameetrid on:\n";
    print "[-i] sisendfail\n";
    print "    [-k] tulemuse_kataloog\n";
    print "    -t	tee ka tekstifail (vajalik morf analüüsile)\n";
    print "    -l	tee ka logifail\n";
    print "    -f	tee ka festivali sisend\n";
    exit;
}


open (STL, "<$stl") or die "Ei saa avada $stl";
binmode (STL);

my $basename = $stl;
$basename = $` if $basename =~ /\.stl$/i;
$basename = $' if $basename =~ /.*\//;

$dir = $basename . '.dir' unless $dir;
$dir = './' . $dir unless $dir =~ /^\//;
system ('mkdir', $dir) unless -d "$dir";

if ($txt) {
    $txt = $dir . '/' . $basename . '.txt';
    open (TXT, ">$txt");
    binmode (TXT, ":utf8");
}
if ($log) {
    $log = $dir . '/' . $basename . '.log';
    open (LOG, ">$log");
    binmode (LOG, ":utf8");
    print LOG "Sisse: $stl, kataloog $dir\n";
}
if ($fst) {
    $fst = $dir . '/' . $basename . '.fst';
    open (FST, ">$fst");
    binmode (FST, ":encoding(ISO-8859-15)");
    print FST "(voice_eki_et_tonu_hts)\n";
}

my $srt = $dir . '/' . $basename . '.srt';
open (SRT, ">$srt") or die "Ei saa teha $srt";
binmode (SRT, ":utf8");

binmode (STDOUT, ":utf8");



# Katsume otsustada, kas fail sisaldab Unicode'i plokke ja on kirillitsa
seek (STL, 14, 0);
read (STL, $languagecode, 2);
print LOG "Keel: $languagecode\n" if $log;

if ($languagecode eq '56') {
    $usr = 1;
    print LOG "LÜLITUN ÜMBER UNICODE'ILE JA KIRILLITSALE\n";
}

seek (STL, 238, 0);	# 0xEE
read (STL, $tnb, 5);





$kogusupatekst = '';
my $fe_tekst = '';
my $fe_number = 0;

for $bnr (0..$tnb) {
    #print "NR $bnr: ";
    seek (STL, 1024+($bnr*128), 0);
    #printf ("POS %06x ", tell(STL));
    read (STL, $sgn, 1);
    $sgn = ord($sgn);
    #print LOG sprintf("SGN %d ", $sgn);
    read (STL, $b, 1); $sn = ord($b);
    read (STL, $b, 1); $sn += 256*ord($b);
    #print LOG sprintf ("SN %d ", $sn);
    read (STL, $ebn, 1);
    $ebn = ord($ebn);
    #print LOG sprintf ("EBN %x", $ebn); 
    #print LOG "\n";

    # F0-FD reserveeritud ja FE kasutaja andmed.
    # Siit laseme edasi kasutaja ja lõpetavad subtiitrid
    next if ($ebn >= 0xF0) and ($ebn < 0xFE);

    seek (STL, 1024+($bnr*128)+5, 0);
    read (STL, $hh, 1);
    read (STL, $mm, 1);
    read (STL, $ss, 1);
    read (STL, $ff, 1);
    $ff = int(ord($ff) * 1000 / 25);
    $tci = sprintf ("%02d:%02d:%02d,%02d", ord($hh), ord($mm), ord($ss), $ff);

    read (STL, $hh, 1);
    read (STL, $mm, 1);
    read (STL, $ss, 1);
    read (STL, $ff, 1);
    $ff = int(ord($ff) * 1000 / 25);
    $tco = sprintf ("%02d:%02d:%02d,%02d", ord($hh), ord($mm), ord($ss), $ff);

    # kui vahe järgmiseni on pikk, siis ei hakka tagant teksti ettepoole ühendama
    my $sellelopp = ord($hh)*60*60 + ord($mm)*60 + ord($ss);

    seek (STL, 1024+($bnr*128)+16, 0);
    $t = '';
    read (STL, $t, 128-16);

    # kui vahe järgmiseni on pikk, siis ei hakka tagant teksti ettepoole ühendama
    my $ajavahe = 100;
    if ($bnr < $tnb) {
	seek (STL, 1024+(($bnr+1)*128)+5, 0);
	read (STL, $hh, 1);
	read (STL, $mm, 1);
	read (STL, $ss, 1);
	$ajavahe = ord($hh)*60*60 + ord($mm)*60 + ord($ss) - $sellelopp;
    }

    # FE - unicode kasutajaplokkides
    # FE peab alati tulema enne FF-i
    # teisendame ära ja hoiame fe_tekst muutujas, hiljem selgub, kas seda ka vaja läheb

    if ($sn != $fe_number) {
	$fe_tekst = '';
	$fe_number = $sn;
    }

    if ($ebn == 0xFE) {
	# muud peale selle FAB formaadi meid ei huvita
	next unless $t =~ /^FABst(.)(.)/;

	$t = $';
	if ($2 eq "\x{04}") {
	    $t = substr ($t, 0, ord($1)-2);
	} else {
	    # /s on vajalik, sest pikkus võib olla 10, mis oleks reavahetus, mis poleks .
	    $t =~ /^..(.)(.)/s;
	    $t = substr ($', 0, ord($1)-2);
	    $t = '' if ($2) and ($2 ne "\x{04}");
	}

	$t = $` if $t =~ /\x{8f}/;
	while ($t =~ /^(..)/) { $t = $'; $_ = unpack "S", $&; $fe_tekst .= chr; }
	$fe_tekst =~ s/\x{2028}/ /g;
	#print "FE_tekst on nyyd $fe_tekst\n";
	next;
    }

    # Siit edasi on kindel, et tegemist ei olnud 'kasutaja' subtiitriga

    $t = $` if $t =~ /\x{8f}/;

    # korjame kokku ühe subtiitri teksti, mis ei mahtunud ühte plokki.
    $kogusupatekst .= $t;

    # Viimase ebn on FF, jääme seda ootama.
    next unless ($ebn == 0xFF);

    # OLI VIIMANE
    $t = $kogusupatekst;
    $kogusupatekst = '';

    if ($usr) {
	$t = kirillitsaasendus ($t);
    } else {
	$t = diakriitikuteasendus ($t);
    }

    # võis juhtuda, et Unicode'i subtiiter on tühi, siis on mõeldud kasutada 'tava'-subtiitrit
    $t = $fe_tekst if ($usr) and ($fe_tekst);

    # pealkirja me järgneva lausega ei yhenda
    $pealkiri = $t;
    $pealkiri =~ s/(osa|jagu)//;		# VÄIKE MAJA PREERIAS 111. osa
    $pealkiri =~ s/<.+>//g;			# V<00e4>IKE ...
    $pealkiri = ( $pealkiri !~ /[a-z]/ );

    # kursiivid jms
    $t =~ s/[\x{00}-\x{1f}\x{80}-\x{89}\x{8b}-\x{8e}\x{90}-\x{9f}]//g;

    # 8A - tegelt reavahetus, aga sünteesi ei huvita
    $t =~ s/([a-zA-Z])\-\x{8a}([a-zA-Z\xc1-\xcf])/$1$2/g;	# poolitus

    # nüüd saab pause vahele lisada, s.t. kriipsud tuleb alles jätta
    $t =~ s/\x{8a}\x{2d} / - /g;				# kõnelejavahetus koos uue reaga

    # Nimi üleval, mitu reavahetust ja supa - panen punkti vahele
    # naishäälega?
    $t =~ s/\x{8a}\x{8a}+/. /g;

    # Kõik muud on lihtsalt kaherealine supa
    $t =~ s/\x{8a}/ /g;

    # kasutatud kohati lopetava jutumargina (ba). paariline on sel juhul (aa)
    $t =~ s/\x{ba}/\"/g;
    $t =~ s/\x{aa}/\"/g;
    # kah jutumärgid. parem asendame siin, et lauselõppu saaks " järgi kontrollida
    $t =~ s/\'\'/\"/g;
    # kasutatud ylakomana enne kaandeloppe
    $t =~ s/\x{b9}/\'/g;

    # teisendame Unicode'iks
    $t =~ s/<u(....)>/chr(hex($1))/egi;

    # Asendame kõneleja vahetuse kriipsukesed
    $t =~ s/\x{00d0}/ /g;
    $t =~ s/ \- / - - /g;
    $t =~ s/^\- /- - /;

    # tyhikud
    $t =~ s/^\s+//;
    $t =~ s/\s+$//;
    $t =~ s/\s\s+/ /g;

    # Liidame eelnenud subtiitrid, mis ulatusid üle lause piiri
    if ($eelmisetekst) {
	print LOG "Yhendan: $sn $eelmisetekst + $t\n" if $log;
	$t = $eelmisetekst . ' ' . $t;
	$tci = $eelmisealgus;
    }

    # Kui supa on 'lause', trykime
    if ( $pealkiri or ($t =~ /[.!?\"]$/) or ($bnr >= $tnb-1) or ($ajavahe > 10) ) {
	# tyhi subtiiter tekitab arvepidamises segadust
	if ($t) {
	    if ( ($tci . $tco) =~ /\x{0a}/s) {
		print LOG "TCI SISALDAB REAVAHETUSI! $sn : $t\n" if $log;
		print "TCI SISALDAB REAVAHETUSI! $sn : $t\n";
	    }
	    print SRT "$sn\n";
	    print SRT $tci;
	    print SRT " --> $tco\n";
	    print SRT "$t\n\n";

	    print TXT "$sn\t$t\n" if $txt;

	    if ($fst) {
	    print FST '(set! utt1 (Utterance Text "' . jutumarkideta($t) . '"))' . "\n";
	    print FST '(utt.synth utt1)' . "\n";
	    print FST '(utt.save.wave utt1 "sn' . $sn . ".wav\")\n\n";
	    }
	}

	$eelmisealgus = '';
	$eelmisetekst = '';
#	print ".";
    }
    else {
	$eelmisealgus = $tci;
	$eelmisetekst = $t;
#	print " -$sn ";
    }
}

close (STL);
close (SRT);
close (FST) if $fst;
close (TXT) if $txt;
close (LOG) if $log;

sub jutumarkideta {
    my $s = shift;
    $s =~ s/\\/\\\\/;
    $s =~ s/\"/\\\"/;
    return $s;
}

sub diakriitikuteasendus {
    my $t = shift;

# b0 on tema ise -- kraadimärk

# graavis c1
    $t =~ s/\x{c1}//g;
# akuut
    $t =~ s/\x{c2}a/<u00e1>/g;
    $t =~ s/\x{c2}A/<u00c1>/g;
    $t =~ s/\x{c2}e/<u00e9>/g;
    $t =~ s/\x{c2}E/<u00c9>/g;
    $t =~ s/\x{c2}o/<u00f3>/g;
    $t =~ s/\x{c2}O/<u00d3>/g;
    $t =~ s/\x{c2}c/<u0107>/g;	# ć == serbohorvaadi nime lõpu tš
    $t =~ s/\x{c2}C/<u0106>/g;
# katus c3
    $t =~ s/\x{c3}//g;
# tilde
    $t =~ s/\x{c4}o/<u00f5>/g;
    $t =~ s/\x{c4}O/<u00d5>/g;
# makron c5
    $t =~ s/\x{c5}//g;
# kaar korea c6
    $t =~ s/\x{c6}//g;
# yks punkt peal: poola z c7
    $t =~ s/\x{c7}//g;
# tapid
    $t =~ s/\x{c8}a/<u00e4>/g;
    $t =~ s/\x{c8}A/<u00c4>/g;
    $t =~ s/\x{c8}o/<u00f6>/g;
    $t =~ s/\x{c8}O/<u00d6>/g;
    $t =~ s/\x{c8}u/<u00fc>/g;
    $t =~ s/\x{c8}U/<u00dc>/g;
# ring
    $t =~ s/\x{ca}a/<u00e5>/g;
    $t =~ s/\x{ca}A/<u00c5>/g;
# sedii
    $t =~ s/\x{cb}c/<u00e7>/g;
    $t =~ s/\x{cb}C/<u00c7>/g;
# haak
    $t =~ s/\x{cf}s/<u0161>/g;
    $t =~ s/\x{cf}S/<u0160>/g;
    $t =~ s/\x{cf}z/<u017e>/g;
    $t =~ s/\x{cf}Z/<u017d>/g;

# ? ce+e = a Maj?a Ostaszewsk?a nimes

# Üllatuste vältimiseks likvideerime veel asendamata diakriitilised märgid
# Näiteks Reykjav'ik jätab c2 sisse ja see tekitab kõnesünteesis prügi
    $t =~ s/[\x{c1}-\x{c8}\x{ca}\x{cb}\x{ce}\x{cf}]//g;

# poola l
    $t =~ s/\x{e8}/L/g;
    $t =~ s/\x{f8}/l/g;
# taani jt AE
    $t =~ s/\x{e1}/<u00c6>/g;
    $t =~ s/\x{f1}/<u00e6>/g;
# islandi eth ja thorn
    $t =~ s/\x{ec}/T/g;	# kontrolli
    $t =~ s/\x{f3}/d/g;
# taani jt o kriipsuga
    $t =~ s/\x{f9}/<u00f8>/g;
# saksa sz
    $t =~ s/\x{fb}/ss/g;
# kraadimull
    $t =~ s/\x{eb}/<u00b0>/g;

    return $t;
}

sub kirillitsaasendus {
    my $t = shift;
    $t =~ s/[\x{b0}-\x{ef}]/'<u' . sprintf("%04x", ord($&)- 0xb0 + 0x0410) . '>'/eg;
    return $t;
}