use utf8;

sub logi {
    my $teade = shift;
    use POSIX;
    print LOG strftime "%F %T\t", localtime;
    print LOG "$teade\n";
}

sub pane_staatus_init {
    my ($n, $i) = @_;
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET staatus_init = ? WHERE nimi = ?});
    $sth->execute($i, $n);
}

sub pane_staatus_morf {
    my ($n, $i) = @_;
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET staatus_morf = ? WHERE nimi = ?});
    $sth->execute($i, $n);
}

sub pane_staatus_heli {
    my ($n, $i) = @_;
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET staatus_heli = ? WHERE nimi = ?});
    $sth->execute($i, $n);
}

sub pane_synteesilukk {
    my ($n, $i) = @_;
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET synteesilukk = ? WHERE nimi = ?});
    $sth->execute($i, $n);
}

sub leia_pane_staatus_heli {
    my $t = shift;
    return unless $t;
    my $srt = $workdir . '/' . $t . '/' . $t . '.srt';
    return unless -e $srt;
    my $tyhirida = 1;
    my $tehtud = 0;
    my $kokku = 0;
    my $tegemataloend = '';

    open (X, "<$srt");
    while (<X>) {
	chomp;
	if ($_ eq '') { $tyhirida = 1; next; }
	if (($tyhirida) and (/^\d+$/)) {
	    $kokku++;
	    if (-e $workdir . '/' . $t . '/sn' . $_ . '.wav') {
		$tehtud++;
	    } else {
		$tegemataloend .= $_ . ' ';
	    }
	}
	$tyhirida = 0;
    }
    close (X);

    # väldime nulliga jagamist kui subtiitreid pole, siis olgu kohe 101%
    my $protsent = ($kokku ? int ($tehtud*100/$kokku) : 101);

    # väldime 100%, see on eritähendusega (liitmine on tehtud)
    $protsent = 99 if $protsent > 99;

    # väldime ka 99% kui midagi on veel teha, sest seegi on eritähendusega
    # (liitmine võib alata). Aga 316 319st oleks 99%
    $protsent-- if ($tehtud < $kokku);

    logi ("$tehtud subtiitrit ${kokku}st, ${protsent}%");
    logi ("veel tegemata nr $tegemataloend") if $protsent > 94;
    pane_staatus_heli ($t, $protsent);
}

sub pane_toimetamisvajadus {
    my ($n, $i) = @_;
    return unless $i =~ /^[1-3]$/;
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET toimetamisvajadus = ? WHERE nimi = ?});
    $sth->execute($i, $n);
}

sub on_kaandelopp {
    my ($s) = @_;
    # kõige prostam omastav
    return 1 if $s =~ /^(\'|\'i|i|a|e)$/o;
    # Versaille's, Whipple'iga
    return 1 if $s =~ /^\'i?(d|t|sse|s|st|le|l|lt|ks|ni|na|ta|ga)$/o;
    # NATO-sse
    return 1 if $s =~ /^\-(d|t|sse|s|st|le|l|lt|ks|ni|na|ta|ga)$/o;
    # Maryt, Johni, Jamesiga etc
    return 1 if $s =~ /^(i|a|e)?(d|t|sse|s|st|le|l|lt|ks|ni|na|ta|ga)$/o;
    # mitmus
    return 1 if $s =~ /^(\'|\'i|i)?(de|te|sid)$/o;
    return 1 if $s =~ /^(\'|\'i|i)?(de|te)(sse|s|st|le|l|lt|ks|ni|na|ta|ga)$/o;
    return 0;
}

sub leia_koige_pakilisem_nimi {
    my $sqlwhere = shift;
    my $kat_noutud = shift;
    my $txt_noutud = shift;

    $sqlwhere .= ' AND (vip = 0)';
    my $sql = 'SELECT nimi FROM j_subtiitrid WHERE ' . $sqlwhere;

    # Leiame tänased eelseisvad tööd
    my $sqlorder = ' ORDER BY ( ' .
	'IF ( ' .
	    'CONCAT(eetris_kuupaev,eetris_kellaaeg) > CONCAT(CURDATE(), CURTIME()), ' .
	    'CONCAT(eetris_kuupaev,eetris_kellaaeg), ' .
	    '9999' .
	')' .
    ') ASC';

    my $sth = $dbh->prepare ($sql . $sqlorder);
    $sth->execute();
    while ( my @t = $sth->fetchrow_array() ) {
	my $t = $t[0];
	next if ($kat_noutud) and (! -d $workdir . '/' . $t);
	next if ($txt_noutud) and (! -e $workdir . '/' . $t . '/' . $t . '.txt');
	return $t;
    }

    return '';
}

sub leia_koige_pakilisem_nimi_vana {
    my $sqlwhere = shift;
    $sqlwhere .= ' AND (vip = 0)';
    my $sql = 'SELECT nimi FROM j_subtiitrid WHERE ' . $sqlwhere;

    # Leiame tänased eelseisvad tööd
    my $sqldate = ' AND (eetris_kuupaev = CURDATE())';
    $sqldate .= ' AND (eetris_kellaaeg > CONVERT(CURTIME() USING utf8) COLLATE utf8_general_ci)';
    my $sqlorder = ' ORDER BY eetris_kuupaev,eetris_kellaaeg ASC';

    my $sth = $dbh->prepare ($sql . $sqldate . $sqlorder);
    $sth->execute();
    while ( my @t = $sth->fetchrow_array() ) {
	my $t = $t[0];
	next unless -d $workdir . '/' . $t;
	next unless -e $workdir . '/' . $t . '/' . $t . '.txt';
	return $t;
    }

    # Kui mitte täna, siis vahest homme?
    $sqldate = ' AND (eetris_kuupaev >= CURDATE())';
    $sth = $dbh->prepare ($sql . $sqldate . $sqlorder);
    $sth->execute();
    while ( my @t = $sth->fetchrow_array() ) {
	my $t = $t[0];
	next unless -d $workdir . '/' . $t;
	next unless -e $workdir . '/' . $t . '/' . $t . '.txt';
	return $t;
    }

    $sqlorder = ' ORDER BY eetris_kuupaev,eetris_kellaaeg DESC';
    $sth = $dbh->prepare ($sql . $sqlorder);
    $sth->execute();
    while ( my @t = $sth->fetchrow_array() ) {
	my $t = $t[0];
	next unless -d $workdir . '/' . $t;
	next unless -e $workdir . '/' . $t . '/' . $t . '.txt';
	return $t;
    }

    return '';
}

sub leia_koige_pakilisem_morf {
    return leia_koige_pakilisem_nimi ('(staatus_morf = 0)', 1, 1);
}

sub leia_koige_pakilisem_heli {
    return leia_koige_pakilisem_nimi ('(staatus_morf = 2) AND (synteesilukk = 0) AND (staatus_heli < 99)', 1, 0);
#   AND (ajanihe <> "x")', 1, 0);
}

sub leia_koige_pakilisem_ootel {
    return leia_koige_pakilisem_nimi ('(staatus_init = 0)', 0, 0);
}

sub ava_uued_tood {
    my $locsth = $dbh->prepare (qq{SELECT stl FROM j_subtiitrid WHERE (staatus_init = 0) ORDER BY eetris_kuupaev,eetris_kellaaeg DESC});
    $locsth->execute();
    while ( my @t = $locsth->fetchrow_array() ) {
	my $t = $t[0];
	logi ("Leidsin uue subtiitrifaili $t");
	if ($t !~ /.*\/(.*)\.(stl|srt)/i) {
	    logi ("Kahjuks kas vale laiendiga voi vales kohas");
	    next;
	}
	ava_uus_too ($t);
    }
}

sub ava_uus_too {
    # sisse failinimi sisendkataloogis
    my $t = shift;

    # failinimest saab töönimi
    $t =~ /.*\/(.*)\.(stl|srt)/i;
    $toonimi = $1;
    my $laiend = $2;

    # kuupäevaks tänane kui see on veel tyhi
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET nimi = ?, 
	pealkiri = IF(pealkiri IS NULL OR pealkiri = '', ?, pealkiri), 
	eetris_kuupaev = IF(eetris_kuupaev IS NULL OR eetris_kuupaev < '2000', CURDATE(), eetris_kuupaev) 
    WHERE stl LIKE ?});
    $sth->execute($toonimi, $toonimi, $t);

    # tekitame uue töö srt ja helifailidele oma 'kodu'.
    # Need on suured, ajutised ja kannatavad kustutamist, pole mõtet baasis hoida
    my $tookataloog = $workdir . '/' . $toonimi;
    mkdir $tookataloog unless -d $tookataloog;

    # Teisendame
    if (lc($laiend) eq 'stl') {
        my $cmd = "$bindir/stl2srt.pl -t -l -f $t $tookataloog";
	logi ("Alustan stl->srt teisendust: $cmd");
	system ($cmd);
    }
    else {
	copy ($t, $tookataloog);
    }

    # Baasi paneme ka subtiitrid tekstina. Võimaldab otsida ja
    # võrrelda, milliseid parandusi on tehtud
    open (F, "<$tookataloog/$toonimi.srt") or die ('SRT pole tekkinudki voi on markamatult kadunud?');
    my $blob = do { local $/; <F> };
    close (F);
    $sth = $dbh->prepare (qq{UPDATE j_subtiitrid SET srt = ? WHERE nimi = ?});
    $sth->execute($blob, $toonimi);

    # Ja registreerime baasis
    pane_staatus_init ($toonimi, 1);
    pane_staatus_morf ($toonimi, 0);
    pane_staatus_heli ($toonimi, 0);

    logi ("SRT valmis");
}

sub sule_valmis_tood {
    my $locsth = $dbh->prepare ("SELECT nimi,ajanihe FROM j_subtiitrid WHERE staatus_heli = 99 ORDER BY eetris_kuupaev,eetris_kellaaeg DESC");
    $locsth->execute();
    while ( my @t = $locsth->fetchrow_array() ) {
	my $t = $t[0];
	next unless -d $workdir . '/' . $t;
	my $ajanihe = $t[1];

	my $cmd = "$bindir/joinwav.pl " . $workdir . '/' . $t . '/' . $t . '.srt';
	$cmd .= " $ajanihe" if $ajanihe;
	logi ("Kaivitan $cmd");
	system ($cmd);

	my $omakataloogis = $workdir . '/' . $t . '/' . $t . '.wav';
	my $valmiskataloogis = '/var/www/programmid/ftp/valmistood/' . $t . '.wav';
	return unless -e $omakataloogis;
	pane_staatus_heli ($t, 100);
	logi ("Tervik $t valmis!");

	`mv $omakataloogis $valmiskataloogis`;
	logi ("Tõstsin ümber $valmiskataloogis");
    }
}

sub sonastik_vaste {
    my ($sone, $keel) = @_;
    $keel = '' unless defined ($keel);
    my $locsth = $dbh->prepare ("SELECT haaldus, keel FROM sonastik WHERE sone = ?");
    $locsth->execute($sone);
    # kui midagi ei leitud, tagastame tyhja
    my $olisonastikus = 0;
    my $t = '';
    while ( my ($hh, $kk) = $locsth->fetchrow_array() ) {
	$hh = $sone unless defined ($hh);
	$hh =~ s/\+//g;
	return ($hh ? $hh : $sone) if $kk eq $keel;	# täpne vaste -- kohe tagasi
	$olisonastikus = 1;
	$t = $hh if $kk eq '';		# muidu tagastame määramata keele häälduse
	$t = $hh unless $t;		# või siis esimese muukeelse, kui muud pole
    }
    return $t if $t;			# mingi hääldus leidus
    return $sone if $olisonastikus;	# sõnastikus, aga vasteta == häälda nagu kirjutatud
    return '';
}

sub sonastik_lisa {
    my ($sone, $keel, $haaldus) = @_;
    my $locsth = $dbh->prepare ("DELETE FROM sonastik WHERE (sone = ?) AND (keel = ?)");
    $locsth->execute($sone, $keel);
    $locsth = $dbh->prepare ("INSERT INTO sonastik (sone, keel, haaldus) VALUES (?, ?, ?)");
    $locsth->execute($sone, $keel, $haaldus);
}

#
# Tee uus fail blabla.txt.err.sn
# ridades tyvi<tab>sub_numbrid_kus_esines
#
sub nimed_snumbriteks {
    my $toonimi = shift;
    my $fn = $workdir . '/' . $toonimi . '/' . $toonimi;
#    my $errf = $fn . '.txt.err.loend';
    if (! -e $errf) {
	logi ("Pidin haaldused valja otsima, aga ei leia $errf");
	return;
    }
    # vigade loendi sisu räsiks sone->sonastikukuju
    my %nimestik = ();
    open (X, "<$errf");
    while (<X>) {
	chomp;
	my ($sone, $sagedus, $tyvi) = split (/\t/);
	$nimestik{$sone} = $tyvi;
    }
    close (X);

    my %tyved = ();
    # srt sisu sisse ja vaatame tekstiosad tsüklis läbi
    my $q = 'SELECT srt FROM j_subtiitrid WHERE nimi = "' . $toonimi . '"';
    my $srt = $dbh->selectrow_array($q);
    my @subs = split (/\n\n/, $srt);
    foreach (@subs) {
	next unless /^\d+/;
	my $sn = $&;
	next unless /.*\n/s;
	my $tx = $';

	foreach (split (/\s+/, $tx)) {
	    s/[.,:;?!\"]//g;	# peaks olema sama, mida morf.pl kasutab
	    next unless (my $tyvi = $nimestik{$_});
	    $tyved{$tyvi} .= ",$sn";
	}
    }

    open (X, ">$fn.txt.err.sn");
    foreach (sort keys %tyved) {
	print X $_, "\t", $tyved{$_}, "\n";
    }
    close (X);
}

sub nimed_baasi {
    my $toonimi = shift;

    my $errf = $workdir . '/' . $toonimi . '/' . $toonimi . '.txt.err.loend';
    if (! -e $errf) {
	logi ("Pidin haaldused baasi panema, aga ei leia $errf");
	return;
    }

    my $nimestik = '';
    open (X, "<$errf");
    while (<X>) {
	next unless /\t/;
	my $sone = $`;
	# läbivate suurtähtedega pole mõtet jännata
	next if $sone !~ /\p{lower}/;
	my $haaldus = sonastik_vaste($sone);
	$nimestik .= "$sone\t$haaldus\n";
    }
    close (X);

    $locsth = $dbh->prepare ("UPDATE j_subtiitrid SET sonastik = ? WHERE nimi = ?");
    $locsth->execute($nimestik, $toonimi);
}

sub wav2mp3 {
    my ($toonimi, $aega) = @_;
    my $katkestusaeg = time + $aega - 5;
    my $dir = $workdir . '/' . $toonimi . '/';
    opendir (D, $dir);
    while ( defined(my $f = readdir(D)) ) {
	next unless $f =~ /(sn\d+)\.wav$/;
	next if -e "$dir$1.mp3";
	system ("lame --silent $dir$& $dir$1.mp3");
	last if time > $katkestusaeg;
    }
    closedir (D);
    return (time > $katkestusaeg ? 0 : 1);
}

# Avab töökataloogis blabla.txt.err.loend ja uuendab
# korrastame võõrnimede loendi kujule sone<tab>sagedus<tab>TYVI<tab>tyve_subtiitrinumbrid

sub uus_vigade_loend {
    my $toonimi = shift;
    my $loend = "$workdir/$toonimi/$toonimi.txt.err.loend";

    open (F, "<$loend") or return;
    my @nimestik = (<F>);
    close (F);

    open (F, ">$loend") or return;
    my $errkokku = 0;
    # sort, et lyhemad tuleksid enne.
    # Tokyos, Tokyo -> lisatakse mõlemad
    # Tokyo, Tokyos -> lisataks esimene, teine tuvastatakse kui tüvi+s
    foreach (sort @nimestik) {
	chomp;
	# kasutame ainult kaks esimest välja - sone ja sageduse, muu teeme uuesti
	next unless /([^\s]+)\t(\d+)/;
	my $sone = $1;
	my $sagedus = $2;

	# kui juba oli sõnastikus, siis on ise tyvi
	if (my $haaldus = sonastik_vaste ($sone)) {
	    print F "$sone\t$sagedus\t$sone\n";
	    next;
	}

	# vene keel ja sõbrad - vähemalt üks ladina täht on nõutav
	next unless $sone =~ /[a-zA-Z]/;

	my $len = length($sone);
	my $tyvileiti = 0;

	# Lühikesi sigineb nii palju, et mõistlikum on valida pigem võimalikult pikk tyvi, mitte lopp
#	for (my $i=6; $i>0; $i--) {
	for (my $i=1; $i<7; $i++) {
	    # eeldame, et tyvi on vähemalt kaks esimest tähte
	    next if $len - $i < 2;
	    my $tyvi = substr($sone, 0, $len-$i);
	    my $lopp = substr($sone, -$i);
#	    logi ("$sone  = $tyvi + $lopp");
	    next unless on_kaandelopp ($lopp);
	    if (my $haaldus = sonastik_vaste ($tyvi)) {
		print F "$sone\t$sagedus\t$tyvi\n";
		$tyvileiti = 1;
		last;
	    }
	}
	next if $tyvileiti;
	sonastik_lisa ($sone, '') if $sone =~ /\p{lower}/;
	$errkokku += $sagedus;
	print F "$sone\t$sagedus\t$sone\n";
    }
    close (F);

    if ($errkokku < 10) { pane_toimetamisvajadus ($toonimi, 1); }
    elsif ($errkokku < 20) { pane_toimetamisvajadus ($toonimi, 2); }
    else { pane_toimetamisvajadus ($toonimi, 3); }
}

sub sonastikuhaaldused {
    my ($aega) = @_;
    my $katkestusaeg = time + $aega - 5;

    my $locsth = $dbh->prepare ("SELECT ID, sone, haaldus FROM sonastik ORDER BY ID DESC");
    $locsth->execute();
    while ( my @t = $locsth->fetchrow_array() ) {
	my $wavfn = $workdir . '/id' . $t[0] . '.wav';
	my $mp3fn = $workdir . '/id' . $t[0] . '.mp3';
	next if (-e $wavfn) and (-e $mp3fn);

	if (! -e $wavfn) {
	
	}
	if (! -e $mp3fn) {
	
	}
    }
}

# festivali sisendfailide tegemine

# peidame jutumärgid

sub fst_escape {
    my $s = shift;
    $s =~ s/\\/\\\\/g;
    $s =~ s/\"/\\\"/g;
    return $s;
}

# kas on vigurdamine ja kas on tavahaal
sub fst_params {
    my ($hh, $hnr) = @_;
    return '' unless $hh;
    return '(redef_params 48000 220 0.55)' . "\n" if $hnr;	# tavaline
    return '(redef_params 46000 190 0.55)' . "\n";		# madalam
#    return '(redef_params 50000 222 0.55)' . "\n";		# korgem
}

# tagastame liigendamata fraasi. sisendiks supa tekst ja supa number

sub fst_tervik {
    my ($st, $sn, $hh) = @_;
    $st = fst_escape($st);
    my $fst_tykk = '';
    $fst_tykk .= fst_params ($hh, 1);
    $fst_tykk .= '(set! utt1 (Utterance Text "' . $st . '"))' . "\n";
    $fst_tykk .= '(utt.synth utt1)' . "\n";
    $fst_tykk .= '(utt.save.wave utt1 "sn' . $sn . ".wav\")\n\n";
    return $fst_tykk;
}

# tagastame juppide sünteesi read.
# sisendiks supa tekst, supa number

sub fst_jupid {
    my ($st, $sn, $hh) = @_;

    # asendame kirjavahemärgid
    # pikad pausid
    $st =~ s/\s+\-[ \-]+\s+/<<p>>/go;		# mõttekriips - kõneleja vahetus
    $st =~ s/(\.\.\.\.*)([?!]+)/$2$1/go;	# mõttepunktide tagant ?! ettepoole
    $st =~ s/\s*\.\.\.[ .]*/<<p>>/go;		# mõttepunktid
    # lühikesed pausid, v.a isikunimed
    $st =~ s/([?!.])\s+(?=\p{upper})/$1<<l>>/go;	# lauselõpud . ? !
    $st =~ s/(\p{upper}\.)<<l>>/$1 /go;	# A.<<l>>H.<<l>>Tammsaare -> A. H. Ta...

    # mitu tükki järjest
    $st =~ s/<<.>>[\" ]*(<<.>>)+/<<p>>/g;
    # algusest ja lõpust maha, mõttepunktid kipuvad seal olema
    $st =~ s/(<<.>>)+$//;
    $st =~ s/^(<<.>>)+//;

    return '' unless $st =~ /<<.>>/;

#print "$st\n\n";

    my $jupinr = 11;				# 11 ilu pärast, kahekohaline, ruumi kuni 99ni
    my $tavahaal = 1;				# tglt boolean, vahetame iga <<p>> korral
    my $pikkus = '';				# lisame jupi failinimesse, paus ees: '', 'l', 'p'
    my $fst_tykk = '';
    $st = fst_escape($st);

    while ( $st =~ /<<(.)>>/ ) {
	$st = $';
	my $jj = $`;
	$fst_tykk .= fst_params ($hh, $tavahaal);
	$fst_tykk .= '(set! uttjupp (Utterance Text "' . $jj . '"))' . "\n";
	$fst_tykk .= '(utt.synth uttjupp)' . "\n";
	$fst_tykk .= '(utt.save.wave uttjupp "sn' . $sn . '_' . $jupinr . $pikkus . ".wav\")\n\n";
	$pikkus = $1;
	$tavahaal = not $tavahaal if $pikkus eq 'p';	# rakendub jargmisele
	$jupinr++;
    }
    $fst_tykk .= fst_params ($hh, $tavahaal);
    $fst_tykk .= '(set! uttjupp (Utterance Text "' . $st . '"))' . "\n";
    $fst_tykk .= '(utt.synth uttjupp)' . "\n";
    $fst_tykk .= '(utt.save.wave uttjupp "sn' . $sn . '_' . $jupinr . $pikkus . ".wav\")\n\n";

    return $fst_tykk;
}

sub tekstihaaldus {
    my $tx = shift;

    # proovime haaldussonastikust mitmesonalisi

    return $tx;
}

sub haaldus {
    my $s = shift;
    # O'Rourke - rekursiivselt, et nii sonastik kui reeglid saaksid sõna sekka öelda
    $s =~ s/^O\'([A-Z]\pL+)/'oo' . haaldus($1)/e;

    my $h = sonastikuhaaldus($s);
    $h = haaldusreeglid($s) if ($h eq $s);
    # muud ülakonad on eeldatavasti käändelõpu eraldajad (Marat'st -> maraa + st)
    $h =~ s/\'//;
    return $h;
}

# sõnastikku pandud rõhud teisendame tühikuteks (eelistatult
# koos eelneva konsonandiga), see on ainus võimalus nendega midagi teha
sub rohk {
    my $s = shift;
    $s =~ s/([aeiou])\'/$1 /g;
    $s =~ s/(.)\'/ $1/g;
    return $s;
}

sub sonastikuhaaldus {
    my $s = shift;
    my $h = '';
    return $s if $s =~ /^[a-z]/;
    return $h if ($h = rohk(sonastik_vaste ($s)));
    my $pikkus = length($s);
    for (my $i=6; $i>0; $i--) {
	next if $pikkus < $i + 2;
	my $tyvi = substr($s, 0, $pikkus-$i);
	my $lopp = substr($s, -$i);
	next unless on_kaandelopp ($lopp);
	return $h . $lopp if ($h = rohk(sonastik_vaste($tyvi)));
    }
    return $s;
}

sub haaldusreeglid {
    my $s = shift;

    # sõna-alguse, suurtäht asendab ^ kontrolli
    $s =~ s/Ma?c(?=[A-Z])/mäk/g;
    $s =~ s/Chl/kl/g;
    $s =~ s/New/njuu/g;

    # igal pool, sestap ka i võti
    $s =~ s/sch/š/gi;
    $s =~ s/tch/tš/gi;
    $s =~ s/chr/kr/gi;	# p.o sch taga
    $s =~ s/[\x{106}\x{107}]/tš/gi;

    return $s;
}

sub transkribeeri {
    my $nimi = lc ($_[0]);
    $nimi =~ s/([аеийоуыэюя])с([аеийоуыэюя])/$1ss$2/go;
    $nimi =~ s/([аеийоуыэюя])с( |$)/$1ss/go;
    $nimi =~ s/([аеийоуыэюя])х([аеийоуыэюя])/$1hh$2/go;
    $nimi =~ s/([аеийоуыэюя])х( |$)/$1hh/go;
    $nimi =~ s/ ([ий])([аеийоуыэюя])/j$2/go;
    $nimi =~ s/ий( |$)/i/go if (length($nimi) > 4);
    $nimi =~ s/ е/je/go;
    $nimi =~ s/([аеийоуыэюяь])е/$1je/go;
    $nimi =~ s/([жчшщ])ё/$1o/go;
    $nimi =~ s/ё/jo/go;
    $nimi =~ s/ьи/ji/go;
    $nimi =~ s/[ъь]//go;
    $nimi =~ s/ц/ts/go;
    $nimi =~ s/ч/tš/go;
    $nimi =~ s/ж/ž/go;
    $nimi =~ s/ш/š/go;
    $nimi =~ s/щ/štš/go;
    $nimi =~ s/ю/ju/go;
    $nimi =~ s/я/ja/go;
    $nimi =~ s/ы/õ/go;
    $nimi =~ tr/абвгдезийклмнопрстуфхэ/abvgdeziiklmnoprstufhe/;
    return $nimi;
}

1;


