#!/usr/bin/perl -w
use Cwd 'abs_path';

# [-i] sisendfaili nimi		peab olema

my $srt = 0;

foreach (@ARGV) {
    if ($_ =~ /^\-/) {
	if (/^\-[itph]$/) { $eelmine = $_; next; }
	next;
    }
    # aga kui ei olnud kriipsuga algav, siis
    if ($eelmine) {
	$srt = $_ if $eelmine eq '-i';
	$eelmine = '';
    }
    # ju siis sisendfail
    else { $srt = $_; }
}

if (! $srt) {
    print "Puudub sisendfaili nimi!\n";
    print "Parameetrid on:\n";
    print "[-i] sisendfail\n";
    print "    -l	tee ka logifail\n";
    print "    -h #	haale number voi r\n";
    exit;
}
die "Ei leia faili $srt" unless -e $srt;

my $progpath = abs_path ($0); # programmikataloog
$progpath = $& if $progpath =~ /.*\//;
my $datapath = abs_path ($srt); # sinna teeme oma failid
$datapath = $& if $datapath =~ /.*\//;

die "Laiend pole srt" unless $srt =~ /\.srt$/i;
my $fst = $` . '.fst';

my $lock = $datapath . 'syntees.lock';
if (-e $lock) {
    die ("Ei saa $fst synteesida, eelmine alles tootab");
    exit;
}

open (LOCK, ">$lock"); print LOCK time; close (LOCK);

system ($progpath . '/srt2fst.pl -hh -i ' . $srt);

chdir ($datapath) or die ('Ei suutnud minna kataloogi ' . $datapath);

system ('/usr/bin/festival -b ' . $fst);

if ($? == -1) { die "festival suri"; }

chdir ($progpath) or die ('Ei suutnud minna kataloogi ' . $progpath);

unlink ($lock);
