#!/usr/bin/perl -w

use utf8;
use DBI();

our $dbh = DBI->connect ("DBI:mysql:<BAAS>:localhost", "<KASUTAJA>", "<PAROOL>", {'RaiseError' => 1});
$dbh->{'mysql_enable_utf8'} = 1;
$dbh->do ("SET NAMES 'utf8'");

# Võrdleb db sonastik välju sone ja vanasone (=sone+haaldus)
# Kui on erinevusi, teeb uue häälduse

my $locsth = $dbh->prepare ("SELECT ID, sone, haaldus FROM sonastik WHERE (CONCAT_WS(' ',sone,haaldus) <> vanasone) LIMIT 500");
my $backsth = $dbh->prepare ("UPDATE sonastik SET vanasone = CONCAT_WS(' ',sone,haaldus) WHERE ID = ?");

$locsth->execute();

while ( my @t = $locsth->fetchrow_array() ) {
    my ($xid, $xsone, $xhaaldus) = @t;
    $xhaaldus = '' unless defined ($xhaaldus);

    tee_haaldusfailid ($xid, $xsone, $xhaaldus);

    $backsth->execute($xid);
}




sub tee_haaldusfailid {
    my ($hid, $hsone, $hhaaldus) = @_;

    my $audiodir = '/var/www/programmid/work/sonastik';
    my $wavfn = $audiodir . '/id' . $hid . '.wav';
    my $mp3fn = $audiodir . '/id' . $hid . '.mp3';
    my $fstfn = $audiodir . '/id' . $hid . '.fst';
    unlink $wavfn if (-e $wavfn);
    unlink $mp3fn if (-e $mp3fn);

    # + häälduses on kokkuleppeliselt toimetajapoolne 'üle vaadatud'
    $hhaaldus =~ s/\+//g;

    # puuduv hääldus olgu sõna ise või kaval teisendus
    $hhaaldus = sone_haalduseks ($hsone) unless $hhaaldus;

    # rõhumärk tühikuks, uue sõna esimesele silbile tuleb automaatselt
    $hhaaldus =~ s/\'/ /g;
    $hhaaldus .= ', ';

    open (FST, ">$fstfn");
    binmode (FST, ":encoding(ISO-8859-15)");
    print FST '(voice_eki_et_tonu_hts)' . "\n";
    # jutumärgid tuleb ära peita
    $hhaaldus =~ s/\\/\\\\/g;
    $hhaaldus =~ s/\"/\\\"/g;
    print FST '(set! utt1 (Utterance Text "' . $hhaaldus . '"))' . "\n";
    print FST '(utt.synth utt1)' . "\n";
    print FST '(utt.save.wave utt1 "' . $wavfn . '")' . "\n\n";
    close (FST);

    system ('/usr/bin/festival -b ' . $fstfn);
#    unlink $fstfn;

    if (! -e $wavfn) { print "wav sonele $hsone ($hid) ikka puudu??\n"; next; }
    # teeme lisaks wav->mp3
    system ("lame --silent $wavfn $mp3fn") if (! -e $mp3fn);
}

sub sone_haalduseks {
    my $s = shift;
    $s =~ s/\'//g;

    $s = 'Mäk' . $1 if $s =~ /^Mc(.+)/;
    $s = 'Mäk' . $1 if $s =~ /^Ma?c(.+)/;

    return $s;
}