#!/usr/bin/perl -w

# tagastab veebilehe hääldustega

use DBI();
use CGI;
use utf8;
use Encode;

binmode (STDOUT, ":utf8");


my $cgiq = CGI->new;
$cgiq->charset("utf-8");
CGI::ReadParse();
foreach (keys %in) { $in{$_} = decode_utf8($in{$_}) }

my $dbh = DBI->connect ("DBI:mysql:<BAAS>:localhost", "<KASUTAJA>", "<PAROOL>", {'RaiseError' => 1});
$dbh->{'mysql_enable_utf8'} = 1;
$dbh->do ("SET NAMES 'utf8'");

my $basedir = '/var/www/programmid';
my $workdir = $basedir . '/work';
my $failinimealus = $workdir . '/' . $in{'nimi'} . '/' . $in{'nimi'};
my $keel = $dbh->selectrow_array ("SELECT keel FROM j_subtiitrid WHERE nimi = " . $dbh->quote($in{'nimi'}) );


# ------------------------------------------------------------------------------

print $cgiq->header();

# ONSUBMIT
if ($in{'tyvi'}) {
    my $q = 'SELECT COUNT(*) FROM sonastik WHERE sone = ' . $dbh->quote($in{'tyvi'}) . ' AND keel = ' .  $dbh->quote($keel);
    my $srt;
    if ($dbh->selectrow_array($q)) {
	$srt = $dbh->prepare('UPDATE sonastik SET haaldus = ?, keel = ? WHERE sone = ?');
	$srt->execute ($in{'haaldus'}, $in{'keel'}, $in{'tyvi'});
	tyhista_synteesid ($in{'id'}, $in{'tyvi'});
    } else {
	$srt = $dbh->prepare('INSERT INTO sonastik (sone, keel, haaldus) VALUES (?, ?, ?)');
	$srt->execute ($in{'tyvi'}, $in{'keel'}, $in{'haaldus'});
    }
    print '<html><head><script type="text/javascript">history.back();</script></head></html>';
    exit;
}


#print $cgiq->header(-refresh=>'5');
print $cgiq->start_html(-title=>'Supa: imelikud sõnad', -lang=>'et');

print <<CSS;
<style type="text/css">
body { font-size:16px; }
.para { padding: 4px; }
.asendus { color: #800000; }
.para:hover { background-color: lightgreen; }
</style>
CSS

my $err = $failinimealus . '.txt.err.loend';
my %errloend = ();
my %hldloend = ();
if (-e $err) {
    open (F, "<$err");
    binmode (F, ":utf8");
    while (<F>) {
	chomp;
	my ($sone, $sagedus, $tyvi, $haaldus) = split (/\t/);
	$errloend{$tyvi} .= '<br>' if $errloend{$tyvi};
	$errloend{$tyvi} .= $sone;
    }
    close (F);
} else { print "<h3>Morfoloogiline analüüs pole veel valmis</h3>"; }

kuvanimekiri();

print $cgiq->end_html;

# ------------------------------------------------------------------------------

sub kuvanimekiri {
    my $cnt = 1;
    print "<table>\n";
    print "<tr><th>Sõnavorm(id)</th><th>~ tüvi</th><th>keel</th><th>Tüve hääldus</th><th>kuula</th></tr>\n";
    my $sth = $dbh->prepare(qq{SELECT ID, keel, haaldus FROM sonastik WHERE sone = ?});

    foreach my $xsone (sort keys %errloend) {
	$sth->execute($xsone);
	while (my @t = $sth->fetchrow_array ()) {
	    my ($xid, $xkeel, $xhaaldus) = @t;
	    $xhaaldus = '' unless defined $xhaaldus;
	    $xhaaldus =~ s/\'/&#39;/g;
	    my $xaudio = &audiotag($xid);
	    print <<TR;
<form action='' name='vorm$cnt'><input type='hidden' name='nimi' value='$in{nimi}'><input type='hidden' name='id' value='$xid'>
<tr>
<td>$errloend{$xsone}</td>
<td><input type='text' name='tyvi' value='$xsone' onChange='document.vorm$cnt.submit()'></td>
<td><input type='text' name='keel' size='3' value='$xkeel' onChange='document.vorm$cnt.submit()'></td>
<td><input type='text' name='haaldus' value='$xhaaldus' onChange='document.vorm$cnt.submit()'></td>
<td>$xaudio</td>
</tr>
</form>
TR
	} # _kõik_ sobivad tyved
	$cnt++;
    }
    print "</table>";
}

sub tyhista_synteesid {
    my $muutunud_id = shift;
    my $muutunudtyvi = shift;
    my %muutunudsoned = ();

    my $logfail = $failinimealus . '.log';
    open (LOG, ">>$logfail");
    binmode (LOG, ":utf8");
    print LOG "tyhistan $muutunudtyvi\n";

    my $errfail = $failinimealus . '.txt.err.loend';
    open (F, "<$errfail");
    binmode (F, ":utf8");
    while (<F>) {
	chomp;
	my ($sone, $sagedus, $tyvi, $haaldus) = split (/\t/);
	$muutunudsoned{$sone} = 1 if $tyvi eq $muutunudtyvi;
    }
    close (F);

    my $snfail = $failinimealus . '.txt.err.sn';
    my $snloend = '';
    open (F, "<$snfail");
    binmode (F, ":utf8");
    while (<F>) {
	chomp;
	my ($sone, $loend) = split (/\t/);
	$snloend .= $loend if $muutunudsoned{$sone};
    }
    close (F);

    # kasutame seda nyyd subtiitrinumbrite jaoks
    %muutunudsoned = ();
    foreach (split (/,/, $snloend)) {
	$muutunudsoned{$_} = 1 if $_;
    }
    foreach (keys %muutunudsoned) {
	my $fn = $workdir . '/' . $in{'nimi'} . '/' . 'sn' . $_;
	unlink ("$fn.wav");
	unlink ("$fn.mp3");
	print LOG "Kustutan $_ muutumise tõttu $fn wav/mp3\n";
    }

    $dbh->do ('UPDATE j_subtiitrid SET staatus_heli = 95 WHERE nimi = ' . $dbh->quote($in{"nimi"}));

    unlink ("$workdir/sonastik/id$muutunud_id.wav");
    unlink ("$workdir/sonastik/id$muutunud_id.mp3");
    print LOG "Kustutasin $_ muutumise tõttu sonastiku hääldused $muutunud_id wav/mp3\n";

    close (LOG);
}

sub audiotag {
    my $id = shift;
    my $fn = '/var/www/programmid/work/sonastik/id' . $id;
    return '' unless -e $fn . '.wav';
    return '' unless -e $fn . '.mp3';
    $fn = '/audio/sonastik/id' . $id;
    my $tag = '<audio id="sstik' . $id . '" preload="none">';
    $tag .= '<source src="' . $fn . '.wav" type="audio/wav">';
    $tag .= '<source src="' . $fn . '.mp3" type="audio/mpeg">';
    $tag .= '</audio>';
    $tag .= '<img src="/audio/audio_16.png" onclick="document.getElementById(' . "'sstik$id'" . ').play();" height="12" width="12">';
    return $tag;
}

sub tekstasendustega {
    my $tx = shift;
    $tx =~ s/\x{e000}(.*?)\x{e001}\x{e002}(.*?)\x{e003}/<span class=\"asendus\">$1<\/span>/g;
    return $tx;
}